﻿/***************** 
 * Template Test *
 *****************/

// init psychoJS:
const psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([0, 0, 0]),
  units: 'height',
  waitBlanking: true
});

// store info about the experiment session:
let expName = 'template';  // from the Builder filename that created this script
let expInfo = {'participant': '', 'group': ''};

// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(setupRoutineBegin());
flowScheduler.add(setupRoutineEachFrame());
flowScheduler.add(setupRoutineEnd());
flowScheduler.add(embedded_formRoutineBegin());
flowScheduler.add(embedded_formRoutineEachFrame());
flowScheduler.add(embedded_formRoutineEnd());
flowScheduler.add(random_seedRoutineBegin());
flowScheduler.add(random_seedRoutineEachFrame());
flowScheduler.add(random_seedRoutineEnd());
flowScheduler.add(youtubeRoutineBegin());
flowScheduler.add(youtubeRoutineEachFrame());
flowScheduler.add(youtubeRoutineEnd());
flowScheduler.add(trial_sliderRoutineBegin());
flowScheduler.add(trial_sliderRoutineEachFrame());
flowScheduler.add(trial_sliderRoutineEnd());
const trials_2LoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trials_2LoopBegin, trials_2LoopScheduler);
flowScheduler.add(trials_2LoopScheduler);
flowScheduler.add(trials_2LoopEnd);
const trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(trialsLoopBegin, trialsLoopScheduler);
flowScheduler.add(trialsLoopScheduler);
flowScheduler.add(trialsLoopEnd);
flowScheduler.add(gender_qRoutineBegin());
flowScheduler.add(gender_qRoutineEachFrame());
flowScheduler.add(gender_qRoutineEnd());
flowScheduler.add(age_qRoutineBegin());
flowScheduler.add(age_qRoutineEachFrame());
flowScheduler.add(age_qRoutineEnd());
flowScheduler.add(debrief_qRoutineBegin());
flowScheduler.add(debrief_qRoutineEachFrame());
flowScheduler.add(debrief_qRoutineEnd());
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({
  expName: expName,
  expInfo: expInfo,
  });


var frameDur;
function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '2020.1.3';
  expInfo['OS'] = window.navigator.platform;

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0 / Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0 / 60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}


var setupClock;
var thisExp;
var win;
var event;
var shuffle;
var round;
var items;
var consent_question;
var key_resp;
var embedded_formClock;
var iframe_loading_2;
var showSlider;
var showLoop;
var showAge;
var showVideo;
var showSeed;
var random_seedClock;
var seedString;
var randomnum1;
var randomnum2;
var kb;
var instructions;
var youtubeClock;
var iframe_loading;
var trial_sliderClock;
var slider;
var loadItemsClock;
var trialClock;
var text;
var thisTrial;
var text_2;
var gender_qClock;
var gender_question;
var Gender;
var age_qClock;
var age_question;
var displayText;
var oldDisplayText;
var age_text;
var debrief_qClock;
var debrief_question;
var Debrief;
var globalClock;
var routineTimer;
function experimentInit() {
  // Initialize components for Routine "setup"
  setupClock = new util.Clock();
  thisExp=psychoJS.experiment;
  win=psychoJS.window;
  event=psychoJS.eventManager;
  Array.prototype.append = [].push;
  shuffle = util.shuffle;
  round = function(num, n=0) {    
      return +(Math.round(num + ("e+" + n))  + ("e-" + n));
  }
  
  
  !function(a,b,c,d,e,f,g,h,i){function j(a){var b,c=a.length,e=this,f=0,g=e.i=e.j=0,h=e.S=[];for(c||(a=[c++]);d>f;)h[f]=f++;for(f=0;d>f;f++)h[f]=h[g=s&g+a[f%c]+(b=h[f])],h[g]=b;(e.g=function(a){for(var b,c=0,f=e.i,g=e.j,h=e.S;a--;)b=h[f=s&f+1],c=c*d+h[s&(h[f]=h[g=s&g+b])+(h[g]=b)];return e.i=f,e.j=g,c})(d)}function k(a,b){var c,d=[],e=typeof a;if(b&&"object"==e)for(c in a)try{d.push(k(a[c],b-1))}catch(f){}return d.length?d:"string"==e?a:a+"\0"}function l(a,b){for(var c,d=a+"",e=0;e<d.length;)b[s&e]=s&(c^=19*b[s&e])+d.charCodeAt(e++);return n(b)}function m(c){try{return o?n(o.randomBytes(d)):(a.crypto.getRandomValues(c=new Uint8Array(d)),n(c))}catch(e){return[+new Date,a,(c=a.navigator)&&c.plugins,a.screen,n(b)]}}function n(a){return String.fromCharCode.apply(0,a)}var o,p=c.pow(d,e),q=c.pow(2,f),r=2*q,s=d-1,t=c["seed"+i]=function(a,f,g){var h=[];f=1==f?{entropy:!0}:f||{};var o=l(k(f.entropy?[a,n(b)]:null==a?m():a,3),h),s=new j(h);return l(n(s.S),b),(f.pass||g||function(a,b,d){return d?(c[i]=a,b):a})(function(){for(var a=s.g(e),b=p,c=0;q>a;)a=(a+c)*d,b*=d,c=s.g(1);for(;a>=r;)a/=2,b/=2,c>>>=1;return(a+c)/b},o,"global"in f?f.global:this==c)};if(l(c[i](),b),g&&g.exports){g.exports=t;try{o=require("crypto")}catch(u){}}else h&&h.amd&&h(function(){return t})}(this,[],Math,256,6,52,"object"==typeof module&&module,"function"==typeof define&&define,"random");
  items = [];
  
  consent_question = new visual.TextStim({
    win: psychoJS.window,
    name: 'consent_question',
    text: 'default text',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0], height: 0.1,  wrapWidth: 1.5, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -3.0 
  });
  
  key_resp = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "embedded_form"
  embedded_formClock = new util.Clock();
  iframe_loading_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'iframe_loading_2',
    text: 'Loading...',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  showSlider=1
  showLoop=1
  showAge=1
  showVideo=1
  showSeed=1
  // Initialize components for Routine "random_seed"
  random_seedClock = new util.Clock();
  seedString = Math.seedrandom();
  randomnum1 = Math.random(); 
  Math.seedrandom(seedString);
  randomnum2 = Math.random(); 
  kb = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true}); 
  
  instructions = new visual.TextStim({
    win: psychoJS.window,
    name: 'instructions',
    text: 'default text',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0], height: 0.1,  wrapWidth: 1.5, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  // Initialize components for Routine "youtube"
  youtubeClock = new util.Clock();
  iframe_loading = new visual.TextStim({
    win: psychoJS.window,
    name: 'iframe_loading',
    text: 'Loading...',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  // Initialize components for Routine "trial_slider"
  trial_sliderClock = new util.Clock();
  slider = new visual.Slider({
    win: psychoJS.window, name: 'slider',
    size: [1.0, 0.1], pos: [0, (- 0.4)], units: 'height',
    labels: undefined, ticks: [1, 2, 3, 4, 5],
    granularity: 0, style: [visual.Slider.Style.RATING],
    color: new util.Color('LightGray'), 
    fontFamily: 'HelveticaBold', bold: true, italic: false, 
    flip: false,
  });
  
  // Initialize components for Routine "loadItems"
  loadItemsClock = new util.Clock();
  // Initialize components for Routine "trial"
  trialClock = new util.Clock();
  text = new visual.TextStim({
    win: psychoJS.window,
    name: 'text',
    text: '',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0], height: 0.1,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  thisTrial = 0;
  
  text_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'text_2',
    text: 'Even (e) or Odd (o)?',
    font: 'Arial',
    units: undefined, 
    pos: [0, 0.45], height: 0.1,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  // Initialize components for Routine "gender_q"
  gender_qClock = new util.Clock();
  gender_question = new visual.TextStim({
    win: psychoJS.window,
    name: 'gender_question',
    text: 'Thank you for participating in our experiment.\n\nIn order to allow us to describe our sample, we would now like you to answer some demographic questions.\n\nWhat is your gender?\n\nWoman (W)\nMan(M)\nNon-binary (N)\nDifferent identity (D)\nPrefer not to say (P)',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0], height: 0.1,  wrapWidth: 1.5, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  Gender = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "age_q"
  age_qClock = new util.Clock();
  age_question = new visual.TextStim({
    win: psychoJS.window,
    name: 'age_question',
    text: 'How old are you (in years)?\nType two digits then enter or 0 for prefer not to say.',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0.1], height: 0.1,  wrapWidth: 1.5, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  displayText = "";
  oldDisplayText = "";
  
  age_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'age_text',
    text: '',
    font: 'Arial',
    units: 'norm', 
    pos: [0, (- 0.2)], height: 0.2,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -2.0 
  });
  
  // Initialize components for Routine "debrief_q"
  debrief_qClock = new util.Clock();
  debrief_question = new visual.TextStim({
    win: psychoJS.window,
    name: 'debrief_question',
    text: 'DEBRIEF GOES HERE\n\nAre you still happy for us to use your data? (Y/N)\n\nThis key press has been disabled to avoid consumption of credits',
    font: 'Arial',
    units: 'norm', 
    pos: [0, 0], height: 0.1,  wrapWidth: 1.5, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  Debrief = new core.Keyboard({psychoJS: psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}


var t;
var frameN;
var _key_resp_allKeys;
var setupComponents;
function setupRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'setup'-------
    t = 0;
    setupClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    kb.clock.reset();
    
    consent_question.setText(('This experiment is being conducted in PsychoPy. Your anonymous data will be saved on the PsychoPy server and then stored securely on Google drive. The collection of personal data will be kept to a minimum to ensure anonymity is maintained.\n\nPlease confirm that you have read and understood the participant information sheet and consent to participant in this experiment by pressing the Y key.\n\nYou are in group: ' + expInfo['group']));
    key_resp.keys = undefined;
    key_resp.rt = undefined;
    _key_resp_allKeys = [];
    // keep track of which components have finished
    setupComponents = [];
    setupComponents.push(consent_question);
    setupComponents.push(key_resp);
    
    setupComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var _pj;
var keys;
var continueRoutine;
function setupRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'setup'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = setupClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    keys = event.getKeys(["y", "quit"], {"waitRelease": true});
    if (_pj.in_es6("quit", keys)) {
        core.quit();
    } else {
        if (_pj.in_es6("y", keys)) {
            continueRoutine = false;
        }
    }
    
    
    // *consent_question* updates
    if (t >= 0.0 && consent_question.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      consent_question.tStart = t;  // (not accounting for frame time here)
      consent_question.frameNStart = frameN;  // exact frame index
      
      consent_question.setAutoDraw(true);
    }

    
    // *key_resp* updates
    if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      key_resp.tStart = t;  // (not accounting for frame time here)
      key_resp.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
    }

    if (key_resp.status === PsychoJS.Status.STARTED) {
      let theseKeys = key_resp.getKeys({keyList: ['y'], waitRelease: false});
      _key_resp_allKeys = _key_resp_allKeys.concat(theseKeys);
      if (_key_resp_allKeys.length > 0) {
        key_resp.keys = _key_resp_allKeys[_key_resp_allKeys.length - 1].name;  // just the last key pressed
        key_resp.rt = _key_resp_allKeys[_key_resp_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    setupComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function setupRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'setup'-------
    setupComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    
    
    psychoJS.experiment.addData('key_resp.keys', key_resp.keys);
    if (typeof key_resp.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('key_resp.rt', key_resp.rt);
        routineTimer.reset();
        }
    
    key_resp.stop();
    // the Routine "setup" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var params;
var continue_routine;
var embedded_formComponents;
function embedded_formRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'embedded_form'-------
    t = 0;
    embedded_formClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    let src = ('form.html?group='+expInfo['group']);
    
    params = {};  // Results added here after form is submitted
    continue_routine = true; // Routines can't be ended from within Begin Routine
    $(document).ready(function() {
        // Add custom contents from html file using an iframe:
        $('body').append('<div id="iframe-o" style="visibility: hidden; position: relative; display: table; margin: auto;"><div id="iframe-m" style="display: table-cell; vertical-align: middle;"><div id="iframe-i" style="display: inline-block; width:100%; overflow-y: auto; overflow-x: hidden;"><iframe id="iframe" src="'+src+'" frameborder="0" style="width: 100%"></iframe></div></div></div>');
    
        $('#iframe').on('load',function(iframe){
            // Auto-adjust iframe size:
            $(this).contents().find('html').css({ 'display': 'table', 'width': '100%', 'overflow-x': 'hidden' });
            $('#iframe-o').height($(window).height()-20, true);
            $('#iframe-m').width($(this).contents().find('html').width()+20);
            $('#iframe-i').height ( Math.min ( $(this).contents().find('html').height()+20, $(window).height()-20 ), true );
            $(this).height($(this).contents().find('html').height());
            $('#iframe-o').css('visibility','visible');
    
            // If iframe contains a form, then capture its output:
            $(this).contents().find('form').on('submit',function(e){
                e.preventDefault();
                $.each($(this).serializeArray(),function(i, param){
                    params[param.name] = param.value;
                    psychoJS.experiment.addData(param.name, param.value);
                });
                console.log ( 'DEBUG:FRM', params );
                // Remove iframe and continue to next routine when done:
                $('#iframe-o').remove();
                continue_routine = false;
            });
        });
    });
    //$('#iframe').attr( 'src', function(i,val){ return val;} );
    // keep track of which components have finished
    embedded_formComponents = [];
    embedded_formComponents.push(iframe_loading_2);
    
    embedded_formComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function embedded_formRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'embedded_form'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = embedded_formClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *iframe_loading_2* updates
    if (t >= 0.0 && iframe_loading_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      iframe_loading_2.tStart = t;  // (not accounting for frame time here)
      iframe_loading_2.frameNStart = frameN;  // exact frame index
      
      iframe_loading_2.setAutoDraw(true);
    }

    continueRoutine = continue_routine;
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    embedded_formComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


var showGender;
function embedded_formRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'embedded_form'-------
    embedded_formComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    showSlider = psychoJS.experiment._currentTrialData['showSlider'];
    showLoop = psychoJS.experiment._currentTrialData['showLoop'];
    if (showLoop === undefined){
        showLoop = 0;
        }
    showAge = psychoJS.experiment._currentTrialData['showAge'];
    showGender = psychoJS.experiment._currentTrialData['showGender'];
    showVideo = psychoJS.experiment._currentTrialData['showVideo'];
    showSeed = psychoJS.experiment._currentTrialData['showSeed'];
    
    // the Routine "embedded_form" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var msg;
var random_seedComponents;
function random_seedRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'random_seed'-------
    t = 0;
    random_seedClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    msg = ((("Testing reseeding random numbers.\n\nrandomnum1: " + randomnum1.toString()) + "\n\nrandomnum2: ") + randomnum2.toString());
    console.log(showSlider);
    console.log(showLoop);
    console.log(showAge);
    console.log(showVideo);
    console.log(showSeed);
    
    instructions.setText((msg + '\n\nPress space to continue'));
    // keep track of which components have finished
    random_seedComponents = [];
    random_seedComponents.push(instructions);
    
    random_seedComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function random_seedRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'random_seed'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = random_seedClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    keys = event.getKeys(["space", "quit"], {"waitRelease": true});
    if (_pj.in_es6("quit", keys)) {
        core.quit();
    } else {
        if ((_pj.in_es6("space", keys) || (showSeed !== 1))) {
            continueRoutine = false;
        }
    }
    
    
    // *instructions* updates
    if (t >= 0.0 && instructions.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      instructions.tStart = t;  // (not accounting for frame time here)
      instructions.frameNStart = frameN;  // exact frame index
      
      instructions.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    random_seedComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function random_seedRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'random_seed'-------
    random_seedComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "random_seed" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var youtubeComponents;
function youtubeRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'youtube'-------
    t = 0;
    youtubeClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    if ((showVideo !== undefined)) {
    let src = 'youtube.html';
    params = {};  // Results added here after form is submitted
    continue_routine = true; // Routines can't be ended from within Begin Routine
    $(document).ready(function() {
        // Add custom contents from html file using an iframe:
        $('body').append('<div id="iframe-o" style="visibility: hidden; position: relative; display: table; margin: auto;"><div id="iframe-m" style="display: table-cell; vertical-align: middle;"><div id="iframe-i" style="display: inline-block; width:100%; overflow-y: auto; overflow-x: hidden;"><iframe id="iframe" src="'+src+'" frameborder=0 style="width: 100%"></iframe></div></div></div>');
    
        $('#iframe').on('load',function(iframe){
            // Auto-adjust iframe size:
            $(this).contents().find('html').css({ 'display': 'table', 'width': '100%', 'overflow-x': 'hidden' });
            $('#iframe-o').height($(window).height()-20, true);
            $('#iframe-m').width($(this).contents().find('html').width()+20);
            $('#iframe-i').height ( Math.min ( $(this).contents().find('html').height()+20, $(window).height()-20 ), true );
            $(this).height($(this).contents().find('html').height());
            $('#iframe-o').css('visibility','visible');
    
            // If iframe contains a form, then capture its output:
            $(this).contents().find('form').on('submit',function(e){
                e.preventDefault();
                $.each($(this).serializeArray(),function(i, param){
                    params[param.name] = param.value;
                    psychoJS.experiment.addData(param.name, param.value);
                });
                console.log ( 'DEBUG:FRM', params );
                // Remove iframe and continue to next routine when done:
                $('#iframe-o').remove();
                continue_routine = false;
            });
        });
    });
    //$('#iframe').attr( 'src', function(i,val){ return val;} );
    }
    // keep track of which components have finished
    youtubeComponents = [];
    youtubeComponents.push(iframe_loading);
    
    youtubeComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function youtubeRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'youtube'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = youtubeClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *iframe_loading* updates
    if (t >= 0.0 && iframe_loading.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      iframe_loading.tStart = t;  // (not accounting for frame time here)
      iframe_loading.frameNStart = frameN;  // exact frame index
      
      iframe_loading.setAutoDraw(true);
    }

    continueRoutine = continue_routine;
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    youtubeComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function youtubeRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'youtube'-------
    youtubeComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "youtube" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var sliderClick;
var trial_sliderComponents;
function trial_sliderRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'trial_slider'-------
    t = 0;
    trial_sliderClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    slider.reset()
    sliderClick = 0;
    
    // keep track of which components have finished
    trial_sliderComponents = [];
    trial_sliderComponents.push(slider);
    
    trial_sliderComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function trial_sliderRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'trial_slider'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = trial_sliderClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *slider* updates
    if (t >= 0.0 && slider.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      slider.tStart = t;  // (not accounting for frame time here)
      slider.frameNStart = frameN;  // exact frame index
      
      slider.setAutoDraw(true);
    }

    if ((showSlider === undefined)) {
        continueRoutine = false;
    } else {
        if (((slider.getRating() !== undefined) && (sliderClick === 0))) {
            sliderClick = t;
        } else {
            if ((sliderClick === 0)) {
            } else {
                if ((t > (sliderClick + 1))) {
                    continueRoutine = false;
                }
            }
        }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    trial_sliderComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function trial_sliderRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'trial_slider'-------
    trial_sliderComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('slider.response', slider.getRating());
    psychoJS.experiment.addData('slider.rt', slider.getRT());
    // the Routine "trial_slider" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var trials_2;
var currentLoop;
function trials_2LoopBegin(thisScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials_2 = new TrialHandler({
    psychoJS: psychoJS,
    nReps: showLoop, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: 'items.xlsx',
    seed: undefined, name: 'trials_2'
  });
  psychoJS.experiment.addLoop(trials_2); // add the loop to the experiment
  currentLoop = trials_2;  // we're now the current loop

  // Schedule all the trials in the trialList:
  trials_2.forEach(function() {
    const snapshot = trials_2.getSnapshot();

    thisScheduler.add(importConditions(snapshot));
    thisScheduler.add(loadItemsRoutineBegin(snapshot));
    thisScheduler.add(loadItemsRoutineEachFrame(snapshot));
    thisScheduler.add(loadItemsRoutineEnd(snapshot));
    thisScheduler.add(endLoopIteration(thisScheduler, snapshot));
  });

  return Scheduler.Event.NEXT;
}


function trials_2LoopEnd() {
  psychoJS.experiment.removeLoop(trials_2);

  return Scheduler.Event.NEXT;
}


var trials;
function trialsLoopBegin(thisScheduler) {
  // set up handler to look after randomisation of conditions etc
  trials = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1000*showLoop, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: undefined,
    seed: undefined, name: 'trials'
  });
  psychoJS.experiment.addLoop(trials); // add the loop to the experiment
  currentLoop = trials;  // we're now the current loop

  // Schedule all the trials in the trialList:
  trials.forEach(function() {
    const snapshot = trials.getSnapshot();

    thisScheduler.add(importConditions(snapshot));
    thisScheduler.add(trialRoutineBegin(snapshot));
    thisScheduler.add(trialRoutineEachFrame(snapshot));
    thisScheduler.add(trialRoutineEnd(snapshot));
    thisScheduler.add(endLoopIteration(thisScheduler, snapshot));
  });

  return Scheduler.Event.NEXT;
}


function trialsLoopEnd() {
  psychoJS.experiment.removeLoop(trials);

  return Scheduler.Event.NEXT;
}


var loadItemsComponents;
function loadItemsRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'loadItems'-------
    t = 0;
    loadItemsClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    items.append([Item, Answer]);
    
    // keep track of which components have finished
    loadItemsComponents = [];
    
    loadItemsComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function loadItemsRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'loadItems'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = loadItemsClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    loadItemsComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function loadItemsRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'loadItems'-------
    loadItemsComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    // the Routine "loadItems" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var responseRecorded;
var timeOut;
var corrAns;
var trialComponents;
function trialRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'trial'-------
    t = 0;
    trialClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    responseRecorded = (- 1);
    timeOut = 0;
    text.setText("+");
    corrAns = items[thisTrial][1];
    
    // keep track of which components have finished
    trialComponents = [];
    trialComponents.push(text);
    trialComponents.push(text_2);
    
    trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var rt;
function trialRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'trial'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = trialClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *text* updates
    if (t >= 0.0 && text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text.tStart = t;  // (not accounting for frame time here)
      text.frameNStart = frameN;  // exact frame index
      
      text.setAutoDraw(true);
    }

    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    if (((timeOut === 0) && (t > 0.5))) {
        text.setText(items[thisTrial][0]);
        timeOut = 1;
    } else {
        if ((((responseRecorded === (- 1)) && (timeOut === 1)) && (t > 1.5))) {
            text.setText("");
            timeOut = 2;
        } else {
            if (((responseRecorded >= 0) && (t > (rt + 1)))) {
                continueRoutine = false;
            } else {
                keys = event.getKeys();
            }
        }
    }
    if ((keys.length && (responseRecorded === (- 1)))) {
        if (_pj.in_es6(corrAns, keys)) {
            text.setText("Correct");
            thisTrial += 1;
            responseRecorded = 1;
            rt = t;
        } else {
            if (_pj.in_es6("e", keys)) {
                text.setText("Incorrect");
                responseRecorded = 0;
                rt = t;
            } else {
                if (_pj.in_es6("o", keys)) {
                    text.setText("Incorrect");
                    responseRecorded = 0;
                    rt = t;
                }
            }
        }
    }
    
    
    // *text_2* updates
    if (t >= 0.0 && text_2.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      text_2.tStart = t;  // (not accounting for frame time here)
      text_2.frameNStart = frameN;  // exact frame index
      
      text_2.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    trialComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function trialRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'trial'-------
    trialComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    if ((thisTrial > 8)) {
        trials.finished = true;
    }
    thisExp.addData("Trial", trials.thisN);
    thisExp.addData("Index", thisTrial);
    thisExp.addData("Item", items[thisTrial][0]);
    thisExp.addData("Answer", items[thisTrial][1]);
    thisExp.addData("Score", responseRecorded);
    rt = (round((rt * 1000)) - 500);
    thisExp.addData("RT", rt);
    
    // the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _Gender_allKeys;
var gender_qComponents;
function gender_qRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'gender_q'-------
    t = 0;
    gender_qClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    Gender.keys = undefined;
    Gender.rt = undefined;
    _Gender_allKeys = [];
    // keep track of which components have finished
    gender_qComponents = [];
    gender_qComponents.push(gender_question);
    gender_qComponents.push(Gender);
    
    gender_qComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function gender_qRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'gender_q'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = gender_qClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *gender_question* updates
    if (t >= 0.0 && gender_question.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      gender_question.tStart = t;  // (not accounting for frame time here)
      gender_question.frameNStart = frameN;  // exact frame index
      
      gender_question.setAutoDraw(true);
    }

    
    // *Gender* updates
    if (t >= 0.0 && Gender.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Gender.tStart = t;  // (not accounting for frame time here)
      Gender.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { Gender.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { Gender.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { Gender.clearEvents(); });
    }

    if (Gender.status === PsychoJS.Status.STARTED) {
      let theseKeys = Gender.getKeys({keyList: ['w', 'm', 'n', 'd', 'p'], waitRelease: false});
      _Gender_allKeys = _Gender_allKeys.concat(theseKeys);
      if (_Gender_allKeys.length > 0) {
        Gender.keys = _Gender_allKeys[_Gender_allKeys.length - 1].name;  // just the last key pressed
        Gender.rt = _Gender_allKeys[_Gender_allKeys.length - 1].rt;
        // a response ends the routine
        continueRoutine = false;
      }
    }
    
    if ((showGender === undefined)) {
        continueRoutine = false;
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    gender_qComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function gender_qRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'gender_q'-------
    gender_qComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('Gender.keys', Gender.keys);
    if (typeof Gender.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('Gender.rt', Gender.rt);
        routineTimer.reset();
        }
    
    Gender.stop();
    // the Routine "gender_q" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var cursorCounter;
var cursorVariable;
var captured_string;
var subject_response_finished;
var age_qComponents;
function age_qRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'age_q'-------
    t = 0;
    age_qClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    cursorCounter = 0;
    cursorVariable = "|";
    captured_string = "";
    subject_response_finished = false;
    event.clearEvents();
    
    // keep track of which components have finished
    age_qComponents = [];
    age_qComponents.push(age_question);
    age_qComponents.push(age_text);
    
    age_qComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


var final_response;
function age_qRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'age_q'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = age_qClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *age_question* updates
    if (t >= 0.0 && age_question.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      age_question.tStart = t;  // (not accounting for frame time here)
      age_question.frameNStart = frameN;  // exact frame index
      
      age_question.setAutoDraw(true);
    }

    var _pj;
    function _pj_snippets(container) {
        function in_es6(left, right) {
            if (((right instanceof Array) || ((typeof right) === "string"))) {
                return (right.indexOf(left) > (- 1));
            } else {
                if (((right instanceof Map) || (right instanceof Set) || (right instanceof WeakMap) || (right instanceof WeakSet))) {
                    return right.has(left);
                } else {
                    return (left in right);
                }
            }
        }
        container["in_es6"] = in_es6;
        return container;
    }
    _pj = {};
    _pj_snippets(_pj);
    if ((cursorCounter >= 30)) {
        if ((cursorVariable === "|")) {
            cursorVariable = " ";
        } else {
            cursorVariable = "|";
        }
        cursorCounter = 0;
    }
    cursorCounter += 1;
    if ((subject_response_finished || (showAge === undefined))) {
        final_response = captured_string;
        continueRoutine = false;
    }
    keys = event.getKeys();
    if (keys.length) {
        if (_pj.in_es6("escape", keys)) {
            core.quit();
        } else {
            if (_pj.in_es6("backspace", keys)) {
                captured_string = captured_string.slice(0, (- 1));
            } else {
                if (_pj.in_es6("delete", keys)) {
                    captured_string = captured_string.slice(0, (- 1));
                } else {
                    if ((_pj.in_es6("return", keys) && ((captured_string === "0") || (captured_string.length === 2)))) {
                        subject_response_finished = true;
                    } else {
                        if ((captured_string.length === 2)) {
                        } else {
                            if (_pj.in_es6("0", keys)) {
                                captured_string = (captured_string + "0");
                            } else {
                                if (_pj.in_es6("1", keys)) {
                                    captured_string = (captured_string + "1");
                                } else {
                                    if (_pj.in_es6("2", keys)) {
                                        captured_string = (captured_string + "2");
                                    } else {
                                        if (_pj.in_es6("3", keys)) {
                                            captured_string = (captured_string + "3");
                                        } else {
                                            if (_pj.in_es6("4", keys)) {
                                                captured_string = (captured_string + "4");
                                            } else {
                                                if (_pj.in_es6("5", keys)) {
                                                    captured_string = (captured_string + "5");
                                                } else {
                                                    if (_pj.in_es6("6", keys)) {
                                                        captured_string = (captured_string + "6");
                                                    } else {
                                                        if (_pj.in_es6("7", keys)) {
                                                            captured_string = (captured_string + "7");
                                                        } else {
                                                            if (_pj.in_es6("8", keys)) {
                                                                captured_string = (captured_string + "8");
                                                            } else {
                                                                if (_pj.in_es6("9", keys)) {
                                                                    captured_string = (captured_string + "9");
                                                                } else {
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
    }
    displayText = (captured_string + cursorVariable);
    if ((displayText !== oldDisplayText)) {
        age_text.setText(displayText);
        oldDisplayText = displayText;
    }
    
    
    // *age_text* updates
    if (t >= 0.5 && age_text.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      age_text.tStart = t;  // (not accounting for frame time here)
      age_text.frameNStart = frameN;  // exact frame index
      
      age_text.setAutoDraw(true);
    }

    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    age_qComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


var age;
function age_qRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'age_q'-------
    age_qComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    age = final_response.replace("\n", ",");
    thisExp.addData("Age", age);
    
    // the Routine "age_q" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


var _Debrief_allKeys;
var debrief_qComponents;
function debrief_qRoutineBegin(trials) {
  return function () {
    //------Prepare to start Routine 'debrief_q'-------
    t = 0;
    debrief_qClock.reset(); // clock
    frameN = -1;
    // update component parameters for each repeat
    Debrief.keys = undefined;
    Debrief.rt = undefined;
    _Debrief_allKeys = [];
    // keep track of which components have finished
    debrief_qComponents = [];
    debrief_qComponents.push(debrief_question);
    debrief_qComponents.push(Debrief);
    
    debrief_qComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent)
        thisComponent.status = PsychoJS.Status.NOT_STARTED;
       });
    
    return Scheduler.Event.NEXT;
  };
}


function debrief_qRoutineEachFrame(trials) {
  return function () {
    //------Loop for each frame of Routine 'debrief_q'-------
    let continueRoutine = true; // until we're told otherwise
    // get current time
    t = debrief_qClock.getTime();
    frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
    // update/draw components on each frame
    
    // *debrief_question* updates
    if (t >= 0.0 && debrief_question.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      debrief_question.tStart = t;  // (not accounting for frame time here)
      debrief_question.frameNStart = frameN;  // exact frame index
      
      debrief_question.setAutoDraw(true);
    }

    
    // *Debrief* updates
    if (t >= 0.0 && Debrief.status === PsychoJS.Status.NOT_STARTED) {
      // keep track of start time/frame for later
      Debrief.tStart = t;  // (not accounting for frame time here)
      Debrief.frameNStart = frameN;  // exact frame index
      
      // keyboard checking is just starting
      psychoJS.window.callOnFlip(function() { Debrief.clock.reset(); });  // t=0 on next screen flip
      psychoJS.window.callOnFlip(function() { Debrief.start(); }); // start on screen flip
      psychoJS.window.callOnFlip(function() { Debrief.clearEvents(); });
    }

    if (Debrief.status === PsychoJS.Status.STARTED) {
      let theseKeys = Debrief.getKeys({keyList: ['y', 'n'], waitRelease: false});
      _Debrief_allKeys = _Debrief_allKeys.concat(theseKeys);
      if (_Debrief_allKeys.length > 0) {
        Debrief.keys = _Debrief_allKeys[_Debrief_allKeys.length - 1].name;  // just the last key pressed
        Debrief.rt = _Debrief_allKeys[_Debrief_allKeys.length - 1].rt;
      }
    }
    
    // check for quit (typically the Esc key)
    if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
      return quitPsychoJS('The [Escape] key was pressed. Goodbye!', false);
    }
    
    // check if the Routine should terminate
    if (!continueRoutine) {  // a component has requested a forced-end of Routine
      return Scheduler.Event.NEXT;
    }
    
    continueRoutine = false;  // reverts to True if at least one component still running
    debrief_qComponents.forEach( function(thisComponent) {
      if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
        continueRoutine = true;
      }
    });
    
    // refresh the screen if continuing
    if (continueRoutine) {
      return Scheduler.Event.FLIP_REPEAT;
    } else {
      return Scheduler.Event.NEXT;
    }
  };
}


function debrief_qRoutineEnd(trials) {
  return function () {
    //------Ending Routine 'debrief_q'-------
    debrief_qComponents.forEach( function(thisComponent) {
      if (typeof thisComponent.setAutoDraw === 'function') {
        thisComponent.setAutoDraw(false);
      }
    });
    psychoJS.experiment.addData('Debrief.keys', Debrief.keys);
    if (typeof Debrief.keys !== 'undefined') {  // we had a response
        psychoJS.experiment.addData('Debrief.rt', Debrief.rt);
        }
    
    Debrief.stop();
    // the Routine "debrief_q" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset();
    
    return Scheduler.Event.NEXT;
  };
}


function endLoopIteration(thisScheduler, loop) {
  // ------Prepare for next entry------
  return function () {
    if (typeof loop !== 'undefined') {
      // ------Check if user ended loop early------
      if (loop.finished) {
        // Check for and save orphaned data
        if (psychoJS.experiment.isEntryEmpty()) {
          psychoJS.experiment.nextEntry(loop);
        }
      thisScheduler.stop();
      } else {
        const thisTrial = loop.getCurrentTrial();
        if (typeof thisTrial === 'undefined' || !('isTrials' in thisTrial) || thisTrial.isTrials) {
          psychoJS.experiment.nextEntry(loop);
        }
      }
    return Scheduler.Event.NEXT;
    }
  };
}


function importConditions(trials) {
  return function () {
    psychoJS.importAttributes(trials.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (psychoJS.experiment.isEntryEmpty()) {
    psychoJS.experiment.nextEntry();
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});
  
  return Scheduler.Event.QUIT;
}
