﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2020.1.3),
    on June 17, 2020, at 14:52
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

from __future__ import absolute_import, division

from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle
import os  # handy system and path functions
import sys  # to get file system encoding

from psychopy.hardware import keyboard



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)

# Store info about the experiment session
psychopyVersion = '2020.1.3'
expName = 'template'  # from the Builder filename that created this script
expInfo = {'participant': ''}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\p0071480\\Documents\\Pavlovia\\template2020\\template_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
# save a log file for detail verbose info
logFile = logging.LogFile(filename+'.log', level=logging.EXP)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run before the window creation

# Setup the Window
win = visual.Window(
    size=[1280, 720], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color=[0,0,0], colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard()

# Initialize components for Routine "consent_q"
consent_qClock = core.Clock()
consent_question = visual.TextStim(win=win, name='consent_question',
    text='This experiment is being conducted in PsychoPy. Your anonymous data will be saved on the PsychoPy server and then stored securely on Google drive. The collection of personal data will be kept to a minimum to ensure anonymity is maintained.\n\nPlease confirm that you have read and understood the participant information sheet and consent to participant in this experiment by pressing the “Y” key.\n\n',
    font='Arial',
    units='norm', pos=(0, 0), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
import random
seedString = core.Clock()
random.seed(seedString)
randomnum1=random.random()
random.seed(seedString)
randomnum2=random.random()

kb = keyboard.Keyboard()

items = []


# Initialize components for Routine "start"
startClock = core.Clock()
instructions = visual.TextStim(win=win, name='instructions',
    text='default text',
    font='Arial',
    units='norm', pos=(0, 0), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);

# Initialize components for Routine "loadItems"
loadItemsClock = core.Clock()

# Initialize components for Routine "trial"
trialClock = core.Clock()
slider = visual.Slider(win=win, name='slider',
    size=(1.0, 0.1), pos=(0, -0.4), units=None,
    labels=None, ticks=(1, 2, 3, 4, 5),
    granularity=0, style=['rating'],
    color='LightGray', font='HelveticaBold',
    flip=False)
text = visual.TextStim(win=win, name='text',
    text=None,
    font='Arial',
    pos=(0, 0), height=0.1, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-1.0);
thisTrial=0

# Initialize components for Routine "gender_q"
gender_qClock = core.Clock()
gender_question = visual.TextStim(win=win, name='gender_question',
    text='Thank you for participating in our experiment.\n\nIn order to allow us to describe our sample, we would now like you to answer some demographic questions.\n\nWhat is your gender?\n\nWoman (W)\nMan(M)\nNon-binary (N)\nDifferent identity (D)\nPrefer not to say (P)',
    font='Arial',
    units='norm', pos=(0, 0), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
Gender = keyboard.Keyboard()

# Initialize components for Routine "age_q"
age_qClock = core.Clock()
age_question = visual.TextStim(win=win, name='age_question',
    text='How old are you (in years)?\nType two digits then enter or 0 for prefer not to say.',
    font='Arial',
    units='norm', pos=(0, .1), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
displayText=''
oldDisplayText=''

age_text = visual.TextStim(win=win, name='age_text',
    text=None,
    font='Arial',
    units='norm', pos=(0, -.2), height=0.2, wrapWidth=None, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "student_q"
student_qClock = core.Clock()
student_question = visual.TextStim(win=win, name='student_question',
    text='Are you a student?\n\nYes, full-time (F)\nYes, part-time (P)\nNo (N)',
    font='Arial',
    units='norm', pos=(0, 0), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
Student = keyboard.Keyboard()

# Initialize components for Routine "debrief_q"
debrief_qClock = core.Clock()
debrief_question = visual.TextStim(win=win, name='debrief_question',
    text='DEBRIEF GOES HERE\n\nAre you still happy for us to use your data? (Y/N)\n\nThis key press has been disabled to avoid consumption of credits',
    font='Arial',
    units='norm', pos=(0, 0), height=0.1, wrapWidth=1.5, ori=0, 
    color='white', colorSpace='rgb', opacity=1, 
    languageStyle='LTR',
    depth=0.0);
Debrief = keyboard.Keyboard()

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "consent_q"-------
continueRoutine = True
# update component parameters for each repeat
kb.clock.reset()  # when you want to start the timer from

# keep track of which components have finished
consent_qComponents = [consent_question]
for thisComponent in consent_qComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
consent_qClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "consent_q"-------
while continueRoutine:
    # get current time
    t = consent_qClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=consent_qClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *consent_question* updates
    if consent_question.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        consent_question.frameNStart = frameN  # exact frame index
        consent_question.tStart = t  # local t and not account for scr refresh
        consent_question.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(consent_question, 'tStartRefresh')  # time at next scr refresh
        consent_question.setAutoDraw(True)
    keys = kb.getKeys(['y','quit'], waitRelease=True)
    if 'quit' in keys:
        core.quit()
    elif 'y' in keys:
        continueRoutine=False
        
    
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in consent_qComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "consent_q"-------
for thisComponent in consent_qComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
msg="INSTRUCTIONS GO HERE\n\nE for even and O for odd\n\nPress the space bar to continue\n\nTesting reseeding random numbers.\n\n"+str(randomnum1) + "\n\n"+str(randomnum2)
# the Routine "consent_q" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "start"-------
continueRoutine = True
# update component parameters for each repeat
instructions.setText(msg+'\n\nPress space to continue')
# keep track of which components have finished
startComponents = [instructions]
for thisComponent in startComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
startClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "start"-------
while continueRoutine:
    # get current time
    t = startClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=startClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *instructions* updates
    if instructions.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        instructions.frameNStart = frameN  # exact frame index
        instructions.tStart = t  # local t and not account for scr refresh
        instructions.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(instructions, 'tStartRefresh')  # time at next scr refresh
        instructions.setAutoDraw(True)
    keys = kb.getKeys(['space','quit'], waitRelease=True)
    if 'quit' in keys:
        core.quit()
    elif 'space' in keys:
        continueRoutine=False
        
    
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in startComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "start"-------
for thisComponent in startComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# the Routine "start" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials_2 = data.TrialHandler(nReps=1, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('items.xlsx'),
    seed=None, name='trials_2')
thisExp.addLoop(trials_2)  # add the loop to the experiment
thisTrial_2 = trials_2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
if thisTrial_2 != None:
    for paramName in thisTrial_2:
        exec('{} = thisTrial_2[paramName]'.format(paramName))

for thisTrial_2 in trials_2:
    currentLoop = trials_2
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
    if thisTrial_2 != None:
        for paramName in thisTrial_2:
            exec('{} = thisTrial_2[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "loadItems"-------
    continueRoutine = True
    # update component parameters for each repeat
    items.append([Item,Answer])
    # keep track of which components have finished
    loadItemsComponents = []
    for thisComponent in loadItemsComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    loadItemsClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "loadItems"-------
    while continueRoutine:
        # get current time
        t = loadItemsClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=loadItemsClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in loadItemsComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "loadItems"-------
    for thisComponent in loadItemsComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    # the Routine "loadItems" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
# completed 1 repeats of 'trials_2'


# set up handler to look after randomisation of conditions etc
trials = data.TrialHandler(nReps=1000, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=[None],
    seed=None, name='trials')
thisExp.addLoop(trials)  # add the loop to the experiment
thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
if thisTrial != None:
    for paramName in thisTrial:
        exec('{} = thisTrial[paramName]'.format(paramName))

for thisTrial in trials:
    currentLoop = trials
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "trial"-------
    continueRoutine = True
    # update component parameters for each repeat
    slider.reset()
    responseRecorded=-1
    timeOut=0
    text.setText("+")
    corrAns=items[thisTrial][1]
    sliderClick=0
    # keep track of which components have finished
    trialComponents = [slider, text]
    for thisComponent in trialComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    trialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "trial"-------
    while continueRoutine:
        # get current time
        t = trialClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=trialClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *slider* updates
        if slider.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            slider.frameNStart = frameN  # exact frame index
            slider.tStart = t  # local t and not account for scr refresh
            slider.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(slider, 'tStartRefresh')  # time at next scr refresh
            slider.setAutoDraw(True)
        
        # *text* updates
        if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            text.frameNStart = frameN  # exact frame index
            text.tStart = t  # local t and not account for scr refresh
            text.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
            text.setAutoDraw(True)
        if timeOut==0 and t > .5:
            text.setText(items[thisTrial][0])
            timeOut=1
        elif responseRecorded==-1 and timeOut == 1 and t > 1.5:
            text.setText("")
            timeOut=2
        elif responseRecorded>=0 and t > rt+1:
            continueRoutine = False
        else:
            keys = event.getKeys()
        
        if len(keys) and responseRecorded==-1:
            if corrAns in keys:
                text.setText("Correct")
                thisTrial +=1
                responseRecorded=1
                rt = t
            elif "e" in keys:
                text.setText("Incorrect")
                responseRecorded=0
                rt = t
            elif "i" in keys:
                text.setText("Incorrect")
                responseRecorded=0
                rt = t
                
        if slider.getRating() != None and sliderClick==0:
            sliderClick=t
        elif sliderClick == 0:
            pass
        elif t > sliderClick+1:
            continueRoutine=False
            
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "trial"-------
    for thisComponent in trialComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials.addData('slider.response', slider.getRating())
    trials.addData('slider.rt', slider.getRT())
    trials.addData('text.started', text.tStartRefresh)
    trials.addData('text.stopped', text.tStopRefresh)
    if thisTrial > 9:
        trials.finished=True
    thisExp.addData("Trial",trials.thisN)
    thisExp.addData("Index",thisTrial)
    thisExp.addData("Item",items[thisTrial][0])
    thisExp.addData("Answer",items[thisTrial][1])
    thisExp.addData("Score",responseRecorded)
    rt=round(rt*1000)-500
    thisExp.addData("RT",rt)
    
    # the Routine "trial" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
# completed 1000 repeats of 'trials'


# ------Prepare to start Routine "gender_q"-------
continueRoutine = True
# update component parameters for each repeat
Gender.keys = []
Gender.rt = []
_Gender_allKeys = []
# keep track of which components have finished
gender_qComponents = [gender_question, Gender]
for thisComponent in gender_qComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
gender_qClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "gender_q"-------
while continueRoutine:
    # get current time
    t = gender_qClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=gender_qClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *gender_question* updates
    if gender_question.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        gender_question.frameNStart = frameN  # exact frame index
        gender_question.tStart = t  # local t and not account for scr refresh
        gender_question.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(gender_question, 'tStartRefresh')  # time at next scr refresh
        gender_question.setAutoDraw(True)
    
    # *Gender* updates
    waitOnFlip = False
    if Gender.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        Gender.frameNStart = frameN  # exact frame index
        Gender.tStart = t  # local t and not account for scr refresh
        Gender.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Gender, 'tStartRefresh')  # time at next scr refresh
        Gender.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(Gender.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(Gender.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if Gender.status == STARTED and not waitOnFlip:
        theseKeys = Gender.getKeys(keyList=['w', 'm', 'n', 'd', 'p'], waitRelease=False)
        _Gender_allKeys.extend(theseKeys)
        if len(_Gender_allKeys):
            Gender.keys = _Gender_allKeys[-1].name  # just the last key pressed
            Gender.rt = _Gender_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in gender_qComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "gender_q"-------
for thisComponent in gender_qComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if Gender.keys in ['', [], None]:  # No response was made
    Gender.keys = None
thisExp.addData('Gender.keys',Gender.keys)
if Gender.keys != None:  # we had a response
    thisExp.addData('Gender.rt', Gender.rt)
thisExp.nextEntry()
# the Routine "gender_q" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "age_q"-------
continueRoutine = True
# update component parameters for each repeat
cursorCounter=0
cursorVariable='|'
captured_string=''
subject_response_finished=False
event.clearEvents()
# keep track of which components have finished
age_qComponents = [age_question, age_text]
for thisComponent in age_qComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
age_qClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "age_q"-------
while continueRoutine:
    # get current time
    t = age_qClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=age_qClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *age_question* updates
    if age_question.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        age_question.frameNStart = frameN  # exact frame index
        age_question.tStart = t  # local t and not account for scr refresh
        age_question.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(age_question, 'tStartRefresh')  # time at next scr refresh
        age_question.setAutoDraw(True)
    if cursorCounter >= 30:
        if cursorVariable=='|':
            cursorVariable=' '
        else:
            cursorVariable='|'
        cursorCounter=0
    cursorCounter+=1
    
    if subject_response_finished:
        final_response=captured_string
        continueRoutine=False
        
    keys = event.getKeys()
    if len(keys):
        if 'escape' in keys:
            core.quit()
        elif 'backspace' in keys:
            captured_string = captured_string[:-1]
        elif 'delete' in keys:
            captured_string = captured_string[:-1]
        elif 'return' in keys and (captured_string=='0' or len(captured_string) ==2):
            subject_response_finished=True
        elif len(captured_string) == 2:
            pass
        elif '0' in keys:
            captured_string = captured_string+'0'
        elif '1' in keys:
            captured_string = captured_string+'1'
        elif '2' in keys:
            captured_string = captured_string+'2'
        elif '3' in keys:
            captured_string = captured_string+'3'
        elif '4' in keys:
            captured_string = captured_string+'4'
        elif '5' in keys:
            captured_string = captured_string+'5'
        elif '6' in keys:
            captured_string = captured_string+'6'
        elif '7' in keys:
            captured_string = captured_string+'7'
        elif '8' in keys:
            captured_string = captured_string+'8'
        elif '9' in keys:
            captured_string = captured_string+'9'
        else:
            pass
    
    displayText = captured_string+cursorVariable
    if displayText != oldDisplayText:
        age_text.setText(displayText)
        oldDisplayText=displayText
    
    # *age_text* updates
    if age_text.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
        # keep track of start time/frame for later
        age_text.frameNStart = frameN  # exact frame index
        age_text.tStart = t  # local t and not account for scr refresh
        age_text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(age_text, 'tStartRefresh')  # time at next scr refresh
        age_text.setAutoDraw(True)
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in age_qComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "age_q"-------
for thisComponent in age_qComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
age = final_response.replace("\n",",")
thisExp.addData('Age',age)

# the Routine "age_q" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "student_q"-------
continueRoutine = True
# update component parameters for each repeat
Student.keys = []
Student.rt = []
_Student_allKeys = []
# keep track of which components have finished
student_qComponents = [student_question, Student]
for thisComponent in student_qComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
student_qClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "student_q"-------
while continueRoutine:
    # get current time
    t = student_qClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=student_qClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *student_question* updates
    if student_question.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        student_question.frameNStart = frameN  # exact frame index
        student_question.tStart = t  # local t and not account for scr refresh
        student_question.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(student_question, 'tStartRefresh')  # time at next scr refresh
        student_question.setAutoDraw(True)
    
    # *Student* updates
    waitOnFlip = False
    if Student.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        Student.frameNStart = frameN  # exact frame index
        Student.tStart = t  # local t and not account for scr refresh
        Student.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Student, 'tStartRefresh')  # time at next scr refresh
        Student.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(Student.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(Student.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if Student.status == STARTED and not waitOnFlip:
        theseKeys = Student.getKeys(keyList=['f', 'p', 'n'], waitRelease=False)
        _Student_allKeys.extend(theseKeys)
        if len(_Student_allKeys):
            Student.keys = _Student_allKeys[-1].name  # just the last key pressed
            Student.rt = _Student_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in student_qComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "student_q"-------
for thisComponent in student_qComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if Student.keys in ['', [], None]:  # No response was made
    Student.keys = None
thisExp.addData('Student.keys',Student.keys)
if Student.keys != None:  # we had a response
    thisExp.addData('Student.rt', Student.rt)
thisExp.nextEntry()
# the Routine "student_q" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# ------Prepare to start Routine "debrief_q"-------
continueRoutine = True
# update component parameters for each repeat
Debrief.keys = []
Debrief.rt = []
_Debrief_allKeys = []
# keep track of which components have finished
debrief_qComponents = [debrief_question, Debrief]
for thisComponent in debrief_qComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
debrief_qClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "debrief_q"-------
while continueRoutine:
    # get current time
    t = debrief_qClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=debrief_qClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *debrief_question* updates
    if debrief_question.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        debrief_question.frameNStart = frameN  # exact frame index
        debrief_question.tStart = t  # local t and not account for scr refresh
        debrief_question.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(debrief_question, 'tStartRefresh')  # time at next scr refresh
        debrief_question.setAutoDraw(True)
    
    # *Debrief* updates
    waitOnFlip = False
    if Debrief.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        Debrief.frameNStart = frameN  # exact frame index
        Debrief.tStart = t  # local t and not account for scr refresh
        Debrief.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(Debrief, 'tStartRefresh')  # time at next scr refresh
        Debrief.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(Debrief.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(Debrief.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if Debrief.status == STARTED and not waitOnFlip:
        theseKeys = Debrief.getKeys(keyList=['y', 'n'], waitRelease=False)
        _Debrief_allKeys.extend(theseKeys)
        if len(_Debrief_allKeys):
            Debrief.keys = _Debrief_allKeys[-1].name  # just the last key pressed
            Debrief.rt = _Debrief_allKeys[-1].rt
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in debrief_qComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "debrief_q"-------
for thisComponent in debrief_qComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
# check responses
if Debrief.keys in ['', [], None]:  # No response was made
    Debrief.keys = None
thisExp.addData('Debrief.keys',Debrief.keys)
if Debrief.keys != None:  # we had a response
    thisExp.addData('Debrief.rt', Debrief.rt)
thisExp.addData('Debrief.started', Debrief.tStartRefresh)
thisExp.addData('Debrief.stopped', Debrief.tStopRefresh)
thisExp.nextEntry()
# the Routine "debrief_q" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv')
thisExp.saveAsPickle(filename)
logging.flush()
# make sure everything is closed down
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
